#pragma once
// 
// https://gitlab.com/zvyagin.alexander/dto-code-generator
// Generated by CODE GENERATOR OF DATA TRANSFER OBJECTS (cgdto) version 0.4.2
// 
// Generated from schema: MonteCarlo SDK version (0.1.4)
// 


#include <optional>
#include <string>
#include <vector>
#include <map>
#include <stdexcept>
#include <cmath>

#include <nlohmann/json.hpp>
using json = nlohmann::json;


#include "Updater.hpp"
namespace dto {
class CorrelatedGaussian;
std::string CorrelatedGaussian_to_json_string(const CorrelatedGaussian &obj);
class CorrelatedGaussian: public Updater {
public:


    
    CorrelatedGaussian (
        float correlation = NAN,
        int state1 = -88,
        int state2 = -88,
        std::string title = ""
    )
    : Updater (
        "CorrelatedGaussian",
        {state1,state2},
        {correlation},
        {},
        title
    )
    {
    }

    bool operator == (const CorrelatedGaussian &other) const {
        if (Updater::operator != (other)) return false;
        return true;
    }
    bool operator != (const CorrelatedGaussian &other) const {return not(*this==other);}
    std::string json (void) const {
        return CorrelatedGaussian_to_json_string(*this);
    }
};
inline
void to_json(json &j, const CorrelatedGaussian &obj) try {
    j = json::object();
    to_json(j,static_cast<const Updater &>(obj));
} catch (const std::exception &e) {
    std::throw_with_nested(std::runtime_error("void to_json(json &j, const CorrelatedGaussian &obj) exception"));
}

inline
std::string CorrelatedGaussian_to_json_string(const CorrelatedGaussian &obj) {
    json j;
    to_json(j,obj);
    return j.dump();
}
inline
void from_json(const json &j, CorrelatedGaussian &obj) try {
    from_json(j,static_cast<Updater &>(obj));
} catch (const std::exception &e) {
    std::throw_with_nested(std::runtime_error("void from_json(const json &j, CorrelatedGaussian &obj) exception"));
}
inline
CorrelatedGaussian CorrelatedGaussian_from_json(const json &j) {
    CorrelatedGaussian obj;
    from_json(j,obj);
    return obj;
}
} // namespace dto

